# Certificate CA

În exercitiul anterioar, am folosit certificatele din folderul
`/etc/ssl/certs` pentru a verifica certificatele serverului. În aceast
exercitiu, vom crea propriul nostru folder de certificate și vom plasa
certificatele corespunzătoare în folder pentru a efectua verificarea.

Prima data vom crea un un folder numit `certs` și vom schimba linia `cadir` din
`handshake.py` astfel:

```python
cadir = ’./certs’
```

**Exercitiu 2**. Determinati certificatul folosit din `/etc/ssl/certs` pentru autentificarea
serverului si copiatil in noul director cu certificate.

---
**Note**

Simpla copiere a certificatului în folderul `./cert` nu este suficientă. Când
TLS încearcă să verifice un certificat de server, va genera o valoare hash din
informațiile de identificare ale emitentului, va folosi această valoare hash ca
parte a numelui de fișier, apoi va folosi acest nume pentru a găsi certificatul
emitentului în folderul `cert`. Prin urmare, trebuie să redenumim fiecare
certificat al CA folosind valoarea hash generată din câmpul subiectului său, sau
putem face un link simbolic din valoarea hash. În comanda următoare, folosim
`openssl` pentru a genera o valoare hash, care este apoi folosită pentru a crea
un link simbolic.

```sh
$ openssl x509 -in someCA.crt -noout -subject_hash
4a6481c9
$ ln -s someCA.crt 4a6481c9.0
$ ls -l
total 4
lrwxrwxrwx 1 ... 4a6481c9.0 -> someCA.crt
-rw-r--r-- 1 ... someCA.crt
```

---