# Server HTTPS

In acest exercitiu vom dezvolta un server de `HTTPS`. Pentru a realiza acest
lucru va trebui sa avem la dispozitie certificatele create la exercitiul
anterior pe care sa le trimitem clientilor.

```python
#!/usr/bin/python3
import socket
import ssl

html = """HTTP/1.1 200 OK\r\nContent-Type: text/html\r\n\r\n<!DOCTYPE html><html><body><h1>Hello, world!</h1></body></html>"""

SERVER_CERT = './server.crt'
SERVER_PRIVATE = './server.key'

context = ssl.SSLContext(ssl.PROTOCOL_TLS_SERVER)
#context = ssl.SSLContext(ssl.PROTOCOL_TLSv1_2) # Ubuntu 16.04
context.load_cert_chain(SERVER_CERT, SERVER_PRIVATE)

sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM, 0)
sock.bind(('0.0.0.0', 4433))
sock.listen(5)

while True:
    newsock, fromaddr = sock.accept()
    ssock = context.wrap_socket(newsock, server_side=True)
    data = ssock.recv(1024) # Read data over TLS
    ssock.sendall(html.encode('utf-8')) # Send data over TLS
    ssock.shutdown(socket.SHUT_RDWR) # Close the TLS connection
    ssock.close()
```

**Exercitiu 4**. Creeati un server HTTPS care reprezinta pagina principala a
site-ului `vine-vacanta.com`. Vom folosi `wget` sau `curl` pentru a testa implementarea.

```
sudo curl --cacert ca.crt https://vine-vacanta.com:4433
```

> Pentru a nu rula serverul cu sudo, nu vom folosi protul `443` folosit implicit de HTTPS. Din cod observam ca folosim portul 4433 pentru server, asa ca o sa rulam cu vine-vacanta.com:4433


**Exercitiu 5**. În aceast exercitiu, vom testa implementarea serverului nostru de HTTPS
**folosind un browser**, cum ar fi Firefox. În primul rând, vom accesa `vine-vacanta.com` din 
browserul. Ce se inampla?  

Pentru ca un browser sa poata stabili o conexiune cu serverul HTTPS, acesta
trebuie să verifice certificatul. Trebuie să aiba certificatul CA-ului care a
emis certificatul serverului. In cazul nostru, CA authority este creat în de noi
si browserul nu o are în lista sa de certificate de încredere.  Trebuie să
adăugăm manual certificatul CA-ului nostru în lista de certificate ale
browserului. Pentru browserul Firefox, faceți clic pe următoarea secvență de
meniu:

```
Edit -> Preference -> Privacy & Security -> View Certificates
```

Veți vedea o listă de certificate care sunt deja acceptate de Firefox. De aici,
putem "importa" propriul nostru certificat. Vă rugăm să importați ca.crt și să
selectați următoarea opțiune: "Trust this CA to identify web sites". Veți vedea
că certificatul Autorității noastre de Certificare se află acum în lista Firefox
a certificatelor acceptate.

**Exercitiu 6**. Conectativa in aceasi retea cu mai multi colegi. Unul dintre voi
va rula serverul, iar ceilalti il vor putea accesa din browser.

> Va trebui sa modificati adresa IP a lui `vine-vacanta.com` in functie de
cine ruleaza serverul.
