# Bit stuffing

O posibilă metodă de framing o reprezintă **bit stuffing**. Vom folosi
`01111110` ca și delimitator de cadre.

De exemplu, dacă vrem să trimitem `0100` atunci o să îl codăm ca și
`01111110|0100|01111110`. Receptorul, doar după ce a primit `0111110` va începe
să citească conținutul cadrului.

Ce facem în cazul în care vrem să trimitem 6 biți de 1, `111111`? Regula este
simplă, după fiecare `11111`, se inserează un 0. Astfel, delimitatorul
`01111110` nu o să apară niciodată în conținutul unui cadru.

```
Sender
111111 -> 1111101

Receiver
1111101 -> 111111
1111100 -> 111110
```

Putem dezvolta astfel un protocol foarte simplu de nivel 2. **Specificatia
acestui protocol** (un fel de
[RFC](https://en.wikipedia.org/wiki/Request_for_Comments)) conține structura
cadrului și regula definită pentru a nu întâlnii delimitatorul în datele pe
care le vom transmite (payload).

```
DELIM|PAYLOAD|DELIM
```
