# Detectarea erorilor de transmisie

În timpul transmiterii de date, pot apărea *erori*. Acestea se pot manifesta ca
biți ai căror valori sunt schimbate într-un cadru. Întâlnim două tipuri de
erori la nivelul legăturii de date:

* cadrele pot fi corupte
* cadrele pot fi pierdute sau pot apărea cadre neașteptate

De exemplu, dacă trimitem șirul de biți `11111111` prin intermediul unui cablu,
din cauza interferențelor electromagnetice, ultimul bit ar putea avea valoarea
schimbată și receptorul ar primi `11111110`.

---

![](images/transmission_errors.png)

---

În general, pentru a putea transmite date peste un link imperfect, vom folosi una
dintre următoarele abordări:

- detectarea erorilor și retransmisia (e.g. CRC, Checksums)
- corectarea erorilor (e.g. Hamming)

În acest caz, apare o decizie de proiectare în dezvoltarea protocolului. De
exemplu, dacă știm că transmisia are loc peste un mediu cu latență mare și
rată mare de corupere a datelor, cum ar fi comunicarea între Pământ și Marte
(~20 de minute), ar avea sens să folosim o metodă de corectare a erorilor. În
schimb, dacă latența este mică, putem să realizăm o retransmisie.
Ethernet folosește un câmp de CRC pentru detectarea erorilor.