## Exerciții

>Pentru laboratorul acesta vom folosi scheletul oferit la adresa:
[lab3](https://gitlab.cs.pub.ro/pcom/pcom-laboratoare-public/-/tree/master/lab3). Tot
acolo se găsește și un README.md cu funcționalitatea disponibilă. Pentru a face update la ultima
variantă a sheletului, folosiți `git pull`.

Vom construi un protocol DataLink peste cel de data trecută, astfel avem deja
implementată funcționalitatea de transmisie de cadre. Avem la dispozitie două
servicii: `link_recv` si `link_send` ce se ocupă de framing și de transmisia
cadrelor. Protocolul nostru este **encapsulat** în payload-ul acelui protocol.
Vom considera un Maximum Transmission Unit (MTU) de 1500 bytes.

```
   |--------------------|
   |LEN|CHECKSUM|PAYLOAD|
   |--------------------|
     \    /
DELIM|PAYLOAD|DELIM -> Laboratorul trecut
```

**1\.** În funcția `simple_csum` din schelet, implementați algoritmul
de checksum așa cum a fost descris în laborator. Vom folosi structura
protocolului definită în `common.h`. Receptorul va afișa `Frame corrupted`
atunci când detectează un cadru corupt. Vom folosi funcția `htonl` pentru a trece valoarea pe care vrem să o scriem
în câmpul `sum` în `Network Order`. Invers, la receiver, vom folosi `ntohl` pentru
a trece în `Host Order`.

---
**Note**

În scriptul `run_experiment.sh` avem câmpul `CORRUPTION` care manipulează rata
de corupere a pachetelor.

---

> Daca primiti stack smash inseamna ca ati facut payload-ul prea mare. El al trebui sa fie
maxim [MAX_LEN](https://gitlab.cs.pub.ro/pcom/pcom-laboratoare-public/-/blob/master/common/link_emulator/lib.h?ref_type=heads#L7) - `sizeof(header)`

**2\.** Vom modifica implementarea precedentă pentru a folosi **CRC 32** în
loc de checksum. 

**3\.** Vom modifica protocolul pentru a realiza o **retransmisie simplă**.
Transmițătorul va trimite un cadru și va aștepta un răspuns de la receptor.
Receptorul, când detectează un cadru corupt, va trimite un cadru prin care îl va
informa pe transmițător de acest lucru (NACK), altfel, **va trimite o confirmare
(ACK)**. Este la latitudinea voastră de cum veți codifica cele două tipuri de
răspunsuri. Vom testa implementarea prin trimiterea unui fișier în chunk-uri ce
nu depasesc dimensiunea maxima impusa de MTU.

> Pe link-ul nostru se strică doar 1 bit / cadru, putem astfel face codificarea ACK/
NACK în așa fel încât dacă este modificată, să putem diferenția între cele 2 tipuri de mesaje.
