## bind()

Utilizată în server pentru a lega un socket de un port și eventual o anumită adresă. 
Practic, bind este folosit pentru a indica implementării de
networking din Kernel să lege acel socket la un anumit port și (opțional) la o anumită adresă IP. 
Astfel, stiva va trimite către acel socket **doar** datagramele ce au ca port destinație portul ales.

``` C
#include <sys/types.h>
#include <sys/socket.h>
   
/*int bind(int sockfd, struct sockaddr *my_addr, int addrlen)*/

struct sockaddr myaddr;
memset(&myaddr, 0, sizeof(servaddr));
myaddr.sin_family = AF_INET; // IPv4
/* INADDR_ANY = 0.0.0.0 as uint32 */
myaddr.sin_addr.s_addr = INADDR_ANY;
myaddr.sin_port = htons(atoi(8888));

int rs = bind(sockfd, myaddr, sizeof(servaddr);
/* in urma apelului, sockfd va avea adresa my_addr */
if (rs == -1) {
  /* trateaza eroare* /
}
```

Explicații:

* `sockfd` - Descriptorul de fișier returnat de `socket()`; 
* `my_addr` - Structura sockaddr ce conține informații despre adresa IP și port;
* `addrlen` - lungimea structurii ce stochează adresa. (a lui `my_addr`).

Pentru a afla mai multe informatii, putem accesa [5.3
bind()—What port am I on?](https://beej.us/guide/bgnet/html/#bind).
