# Controlul Congestiei

Am văzut în laboratoarele precedente că dimensiunea ferestrei transmițătorului
era calculată în funcție de BDP.
În cazul în care considerăm că
dimensiunea maximă a unui segment este **Maximum Segment Size (MSS)**, atunci am
putea calcula dimensiunea optimă a ferestrei ca fiind `BDP / MSS`. Totuși, **ce
facem atunci când avem mai mulți transmițători ce împart același link?**

Fie următoarea topologie în care avem 2 transmițători care împart un link către H3.

![](images/cc_example.png)

Dacă atât H1 cât și H2 ar avea un throughput de transmisie de 50 Mb/s, atunci am
ajunge la 100 Mb/s pe link-ul către H3, ce are o capacitate de doar 50 Mb/s.
Acest lucru va rezulta în pierderea segmentelor și retransmisia.

> Pierderile apar de la faptul ca buffer-ul din router se umple.
El poate trimite catre `h2` cu 50 Mb/s in timp ce primeste
pachete la 100 Mb/s de la `h1` si `h3`.

Pentru a evita acest colaps al rețelei cauzat de congestie, transmițătorul
va trebui să își limiteze dimensiunea ferestrei de transmisie. În acest
scop, introducem **Congestion Window (CWND)**, ce reprezintă fereastra de
congestie, care este numarul de octeti pe care transmitatorul ii poate trimite fara a astepta o confirmare.

Fereastra de congestie este exprimata de obicei in octeti pentru a permite folosirea segmentelor de dimensiuni variabile de catre transmitator. Alternativ,
ea poate fi exprimata in unitati, unde fiecare unitate reprezinta un segment de dimensiune maxima (MSS, sau Maximum Segment Size. In Internet MSS este in jurul 1500B). 

Fereastra de congestie este actualizata dinamic de catre transmitator. Fereastra va creste atunci cand nu exista congestie, si va fi redusa atunci cand reteaua este congestionata. Valoarea minima a ferestrei este de 1MSS.
